models/Formulario.php
<?php
namespace app\models;

use yii\base\Model;
class Formulario extends Model{
/*
    tenemos que crear los campos del formulario
*/
public ?int $numero1=null;
public ?int $numero2=null;
public ?string $descripcion=null;

public function attributeLabels(){
    return [
        "numero1" => "Numero 1",
        "numero2" => "Numero 2",
        "descripcion" => "Descripcion"
    ];
}

public function rules(){
    return [
        [['numero1','numero2','descripcion'],'required'],
    ];
}

public function suma(){
    return $this->numero1+$this->numero2;
}


/**
 * vocales
 * @return int
 * @deprecated 
 */
public function vocales(){
    $vector=str_split($this->descripcion);
    $vocales=0;
    foreach ($vector as $caracter) {
        switch (strtolower($caracter)) {
            case 'a':
            case 'e':
            case 'i':
            case 'o':                                               
            case 'u':                        
                $vocales++;
                break;
        }
    }
    return $vocales;
}

public function vocales1(){
    $vector=str_split($this->descripcion);
    $vocales=0;
    foreach ($vector as $caracter) {
        if(in_array(strtolower($caracter),['a','e','i','o','u'])){
            $vocales++;
        }
    }
    return $vocales;
}
}

models/Formulario1.php
<?php
namespace app\models;

use yii\base\Model;
class Formulario1 extends Model{
/*
    tenemos que crear los campos del formulario
*/
public ?int $numero1=null;
public ?int $numero2=null;
public function attributeLabels(){
    return [
        "numero1" => "Numero 1",
        "numero2" => "Numero 2",
    ];
}

public function rules(){
    return [
        [['numero1','numero2'],'required','message'=>'El campo {attribute} es obligatorio'],
        //[['numero1'],'integer','max'=>100,'min'=>0],
        //[['numero2'],'integer'],
        [['numero1','numero2'],'integer'],
        [['numero1'],function($atributo){
            if(!($this->$atributo>0 && $this->$atributo<100)){
                    return $this->addError($atributo,"El numero1 debe estar entro 0 y 100");
            }
        }],
        [['numero2'], 'compare', 'compareValue' => 0, 'operator' => '!=', 'type' => 'number'],
    ];
}

public function suma(){
    return $this->numero1+$this->numero2;
}

public function resta(){
    return $this->numero1-$this->numero2;
}
public function producto(){
    return $this->numero1*$this->numero2;
}
public function cociente(){
    return $this->numero1/$this->numero2;
}

function operacion($operador){
    //$this->$operador();
    switch ($operador) {
        case 'suma':
            return $this->suma();
        case 'resta':
            return $this->resta();
        case 'producto':
            return $this->producto();
        case 'cociente':
            return $this->cociente();
    }
}

}

models/User.php
<?php

namespace app\models;

class User extends \yii\base\BaseObject implements \yii\web\IdentityInterface
{
    public $id;
    public $username;
    public $password;
    public $authKey;
    public $accessToken;

    private static $users = [
        '100' => [
            'id' => '100',
            'username' => 'admin',
            'password' => 'admin',
            'authKey' => 'test100key',
            'accessToken' => '100-token',
        ],
        '101' => [
            'id' => '101',
            'username' => 'demo',
            'password' => 'demo',
            'authKey' => 'test101key',
            'accessToken' => '101-token',
        ],
    ];


    /**
     * {@inheritdoc}
     */
    public static function findIdentity($id)
    {
        return isset(self::$users[$id]) ? new static(self::$users[$id]) : null;
    }

    /**
     * {@inheritdoc}
     */
    public static function findIdentityByAccessToken($token, $type = null)
    {
        foreach (self::$users as $user) {
            if ($user['accessToken'] === $token) {
                return new static($user);
            }
        }

        return null;
    }

    /**
     * Finds user by username
     *
     * @param string $username
     * @return static|null
     */
    public static function findByUsername($username)
    {
        foreach (self::$users as $user) {
            if (strcasecmp($user['username'], $username) === 0) {
                return new static($user);
            }
        }

        return null;
    }

    /**
     * {@inheritdoc}
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * {@inheritdoc}
     */
    public function getAuthKey()
    {
        return $this->authKey;
    }

    /**
     * {@inheritdoc}
     */
    public function validateAuthKey($authKey)
    {
        return $this->authKey === $authKey;
    }

    /**
     * Validates password
     *
     * @param string $password password to validate
     * @return bool if password provided is valid for current user
     */
    public function validatePassword($password)
    {
        return $this->password === $password;
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::class,
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::class,
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }
    public function actionFormulario()
    {
        $model = new \app\models\Formulario();

        if ($model->load(Yii::$app->request->post())) {
            if ($model->validate()) {
                // mando los resultados a la vista
                return $this->render('solucion',[
                    "model" => $model,
                ]);
            }
        }

        return $this->render('formulario', [
            'model' => $model,
        ]);
    }

    public function actionFormulario1()
    {
        $model = new \app\models\Formulario1();

        if ($model->load(Yii::$app->request->post())) {
            if ($model->validate()) {
                return $this->render("solucion1",[
                    "model" => $model
                ]);
            }
        }

        return $this->render('formulario1', [
            'model' => $model,
        ]);
    }
}

views/layouts/main.php
<?php

/** @var yii\web\View $this */
/** @var string $content */

use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap5\Breadcrumbs;
use yii\bootstrap5\Html;
use yii\bootstrap5\Nav;
use yii\bootstrap5\NavBar;

AppAsset::register($this);

$this->registerCsrfMetaTags();
$this->registerMetaTag(['charset' => Yii::$app->charset], 'charset');
$this->registerMetaTag(['name' => 'viewport', 'content' => 'width=device-width, initial-scale=1, shrink-to-fit=no']);
$this->registerMetaTag(['name' => 'description', 'content' => $this->params['meta_description'] ?? '']);
$this->registerMetaTag(['name' => 'keywords', 'content' => $this->params['meta_keywords'] ?? '']);
$this->registerLinkTag(['rel' => 'icon', 'type' => 'image/x-icon', 'href' => Yii::getAlias('@web/favicon.ico')]);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">
<head>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body class="d-flex flex-column h-100">
<?php $this->beginBody() ?>

<header id="header">
    <?php
    NavBar::begin([
        'brandLabel' => Yii::$app->name,
        'brandUrl' => Yii::$app->homeUrl,
        'options' => ['class' => 'navbar-expand-md navbar-dark bg-dark fixed-top']
    ]);
    echo Nav::widget([
        'options' => ['class' => 'navbar-nav'],
        'items' => [
            ['label' => 'Home', 'url' => ['/site/index']],
            ['label' => 'Formulario', 'url' => ['/site/formulario']],
            ['label' => 'Formulario1', 'url' => ['/site/formulario1']],
        ]
    ]);
    NavBar::end();
    ?>
</header>

<main id="main" class="flex-shrink-0" role="main">
    <div class="container">
        <?php if (!empty($this->params['breadcrumbs'])): ?>
            <?= Breadcrumbs::widget(['links' => $this->params['breadcrumbs']]) ?>
        <?php endif ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</main>

<footer id="footer" class="mt-auto py-3 bg-light">
    <div class="container">
        <div class="row text-muted">
            <div class="col-md-6 text-center text-md-start">&copy; My Company <?= date('Y') ?></div>
            <div class="col-md-6 text-center text-md-end"><?= Yii::powered() ?></div>
        </div>
    </div>
</footer>

<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>

views/site/error.php
<?php

/** @var yii\web\View $this */
/** @var string $name */
/** @var string $message */
/** @var Exception$exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/formulario.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/** @var yii\web\View $this */
/** @var app\models\Formulario $model */
/** @var ActiveForm $form */
?>
<div class="site-formulario">

    <?php $form = ActiveForm::begin(); ?>

        <?= $form->field($model, 'numero1') ?>
        <?= $form->field($model, 'numero2') ?>
        <?= $form->field($model, 'descripcion') ?>
    
        <div class="form-group">
            <?= Html::submitButton('Submit', ['class' => 'btn btn-primary']) ?>
        </div>
    <?php ActiveForm::end(); ?>

</div><!-- site-formulario -->

views/site/formulario1.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/** @var yii\web\View $this */
/** @var app\models\Formulario1 $model */
/** @var ActiveForm $form */
?>
<div class="site-formulario1">

    <?php $form = ActiveForm::begin(); ?>

        <?= $form->field($model, 'numero1') ?>
        <?= $form->field($model, 'numero2') ?>
    
        <div class="form-group">
            <?= Html::submitButton('Submit', ['class' => 'btn btn-primary']) ?>
        </div>
    <?php ActiveForm::end(); ?>

</div><!-- site-formulario1 -->

views/site/index.php
<?php

/** @var yii\web\View $this */

$this->title = 'Ejemplo de formularios';
?>
<div class="site-index">

    <div class="jumbotron text-center bg-transparent mt-5 mb-5">
        <h1 class="display-4">Ejemplos basicos de formularios</h1>

        
    </div>

    
</div>

views/site/solucion.php
<?php

use yii\widgets\DetailView;

echo DetailView::widget([
    "model" => $model
]);
?>

<div>Suma: <?= $model->suma() ?></div>
<div>Vocales: <?= $model->vocales1() ?></div>

views/site/solucion1.php
<?php

use yii\widgets\DetailView;

echo DetailView::widget([
    "model" => $model,
    "attributes" => [
        "numero1",
        "numero2",
        [
            "attribute" => "Suma de los numeros",
            "value" => function($model){
                return  $model->suma();
            }
        ],
    ]
]);
?>

<div>Suma: <?= $model->suma() ?></div>
<div>Resta: <?= $model->resta() ?></div>
<div>producto: <?= $model->producto() ?></div>
<div>cociente: <?= $model->operacion("cociente") ?></div>